Imports FarPoint.Win
Imports FarPoint.Win.Spread

Public Class Form1

    ' Work-around: Ensure ColumnEditName column is first column in data source.

    ' To see problem, use Employees2.
    ' To see work-around, use Employees.

    Private m_DataSet As New DataSet

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_DataSet.ReadXml("..\..\TestData.xml")

        With m_DataSet.Tables("Customers")
            .Columns.Add("SalesRepID2", GetType(Integer))
            For Each row As DataRow In .Rows
                row("SalesRepID2") = row("SalesRepID")
            Next
        End With

        Me.FpSpread1.ButtonDrawMode = ButtonDrawModes.CurrentCell

        Dim multi As New Spread.CellType.MultiColumnComboBoxCellType()
        With multi
            ' Work-around - no problem.
            .DataSourceList = m_DataSet.Tables("Employees")
            ' Problem.
            '.DataSourceList = m_DataSet.Tables("Employees2")
            .ColumnEditName = "EmployeeName"
            .DataColumnName = "EmployeeID"
            .ListWidth = 800
            .ListOffset = -700
        End With

        With Me.FpSpread1.ActiveSheet
            .DataSource = m_DataSet.Tables("Customers")
            .Columns(.ColumnCount - 1).CellType = multi
        End With

        Dim view As New DataView(m_DataSet.Tables("Employees"))
        view.Sort = "EmployeeID"
        Me.FpSpread2.DataSource = view

        With Me.FpSpread1.ActiveSheet
            .Cells(0, .ColumnCount - 1).Value = .Cells(0, .ColumnCount - 1).Value
            .Columns(.ColumnCount - 1).Width = .Columns(.ColumnCount - 1).GetPreferredWidth
        End With

    End Sub

    Private Sub FpSpread1_ComboCloseUp(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.EditorNotifyEventArgs) Handles FpSpread1.ComboCloseUp
        If Me.chkGetPreferredWidthMethod.Checked Then
            With Me.FpSpread1.ActiveSheet
                .Columns(.ColumnCount - 1).Width = .Columns(.ColumnCount - 1).GetPreferredWidth
            End With
        End If
    End Sub

End Class
